module     p0_dd_emnebardu_d39h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p0_dd_emnebardu/helicity0/d39h0l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d39
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd39h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t2 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t3 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t4 = (spvak6k4(1)*qshift(1)-spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(3)-sp&
      &vak6k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb39n15+t1*abb39n26+abb39n18*dotproduct(qshift, qshift)+a&
         &bb39n20*(spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k4(3)*qshif&
         &t(3)-spvak5k4(4)*qshift(4))+abb39n21*(spvak3k2(1)*qshift(1)-spvak3k2(2&
         &)*qshift(2)-spvak3k2(3)*qshift(3)-spvak3k2(4)*qshift(4))+abb39n22*(spv&
         &ak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-spvak6k&
         &2(4)*qshift(4))+abb39n23*dotproduct(k2, qshift)+abb39n25*dotproduct(k5&
         &, qshift)+abb39n27*(spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5&
         &k1(3)*qshift(3)-spvak5k1(4)*qshift(4))+t1*t2*abb39n16+t1*t3*abb39n17+t&
         &1*t4*abb39n19)
         return
      end if
      t5 = spvak5k2(iv1)
      t6 = spvak3k1(iv1)
      t7 = spvak6k1(iv1)
      t8 = spvak6k4(iv1)
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb39n23+k5(iv1)*abb39n25+qshift(iv1)*abb39n24+spv&
         &ak3k2(iv1)*abb39n21+spvak5k1(iv1)*abb39n27+spvak5k4(iv1)*abb39n20+spva&
         &k6k2(iv1)*abb39n22+t5*abb39n26+t1*t6*abb39n17+t1*t7*abb39n16+t1*t8*abb&
         &39n19+t2*t5*abb39n16+t3*t5*abb39n17+t4*t5*abb39n19)
         return
      end if
      t1 = spvak5k2(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb39n18+spvak3k1(iv2)*t5*abb39n17+spv&
         &ak6k1(iv2)*t5*abb39n16+spvak6k4(iv2)*t5*abb39n19+t1*t6*abb39n17+t1*t7*&
         &abb39n16+t1*t8*abb39n19)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d39:
   subroutine     reconstruct_d39(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group0
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group0), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_39:
      coeffs%coeffs_39%c0 = derivative(czip)
      coeffs%coeffs_39%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_39%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_39%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_39%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_39%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_39%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_39%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_39%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_39%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_39%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_39%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_39%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_39%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_39%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_39:
   end subroutine reconstruct_d39
!---#] subroutine reconstruct_d39:
end module p0_dd_emnebardu_d39h0l1d
