module     p0_dd_emnebardu_d11h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p0_dd_emnebardu/helicity1/d11h1l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d11
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd11h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      real(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k3+k6+k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t15 = dotproduct(k2, qshift)
      t16 = dotproduct(k3, qshift)
      t17 = dotproduct(k4, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      t3 = (spvak1k5(1)*qshift(1)-spvak1k5(2)*qshift(2)-spvak1k5(3)*qshift(3)-sp&
      &vak1k5(4)*qshift(4))
      t4 = (spvak6k4(1)*qshift(1)-spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(3)-sp&
      &vak6k4(4)*qshift(4))
      t5 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb11n20+t1*abb11n40+t15*abb11n38+t16*abb11n39+t17*abb11n3&
         &9+t2*abb11n41+t3*abb11n47+abb11n29*dotproduct(qshift, qshift)+abb11n37&
         &*dotproduct(k6, qshift)+abb11n42*(spvak6k5(1)*qshift(1)-spvak6k5(2)*qs&
         &hift(2)-spvak6k5(3)*qshift(3)-spvak6k5(4)*qshift(4))+abb11n43*dotprodu&
         &ct(k5, qshift)+abb11n45*dotproduct(k1, qshift)+t1*t3*abb11n22+t15*t3*a&
         &bb11n24+t16*t3*abb11n23+t17*t3*abb11n23+t2*t3*abb11n21+t3*t4*abb11n25+&
         &t3*t5*abb11n27)
         return
      end if
      t6 = k2(iv1)
      t7 = k3(iv1)
      t8 = k4(iv1)
      t9 = spvak1k5(iv1)
      t10 = spvak3k2(iv1)
      t11 = spvak3k4(iv1)
      t12 = t9*abb11n50
      t13 = spvak6k2(iv1)
      t14 = spvak6k4(iv1)
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb11n28+k5(iv1)*abb11n30+k6(iv1)*abb11n36+qshift(&
         &iv1)*abb11n44+spvak6k5(iv1)*abb11n31+t10*abb11n32+t11*abb11n33+t12*t16&
         &+t12*t17+t6*abb11n35+t7*abb11n34+t8*abb11n34+t9*abb11n26+t1*t9*abb11n5&
         &1+t10*t3*abb11n52+t11*t3*abb11n51+t13*t3*abb11n46+t14*t3*abb11n48+t15*&
         &t9*abb11n49+t2*t9*abb11n52+t3*t6*abb11n49+t3*t7*abb11n50+t3*t8*abb11n5&
         &0+t4*t9*abb11n48+t5*t9*abb11n46)
         return
      end if
      t1 = spvak1k5(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb11n29+k2(iv2)*t9*abb11n24+k3(iv2)*t&
         &9*abb11n23+k4(iv2)*t9*abb11n23+spvak3k2(iv2)*t9*abb11n21+spvak3k4(iv2)&
         &*t9*abb11n22+spvak6k2(iv2)*t9*abb11n27+spvak6k4(iv2)*t9*abb11n25+t1*t1&
         &0*abb11n21+t1*t11*abb11n22+t1*t13*abb11n27+t1*t14*abb11n25+t1*t6*abb11&
         &n24+t1*t7*abb11n23+t1*t8*abb11n23)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d11:
   subroutine     reconstruct_d11(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_11:
      coeffs%coeffs_11%c0 = derivative(czip)
      coeffs%coeffs_11%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_11%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_11%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_11%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_11%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_11%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_11%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_11%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_11%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_11%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_11%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_11%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_11%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_11%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_11:
   end subroutine reconstruct_d11
!---#] subroutine reconstruct_d11:
end module p0_dd_emnebardu_d11h1l1d
