module     p17_ddbar_neepdubar_d8h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p17_ddbar_neepdubar/helicity0/d8h0l1.f90
   ! generator: haggies (1.1)
   use p17_ddbar_neepdubar_config, only: ki
   use p17_ddbar_neepdubar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p17_ddbar_neepdubar_groups, only: &
!           & sign => diagram8_sign, shift => diagram8_shift
      use p17_ddbar_neepdubar_globalsl1, only: epspow
      use p17_ddbar_neepdubar_kinematics
      use p17_ddbar_neepdubar_abbrevd8h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d8
      complex(ki) :: t1

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k6-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d8 = 0.0_ki
      t1 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      d8 = (t1*abb8n8+abb8n5*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)&
      &-Q(4)*spvak5k4(4))+abb8n6*(Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))+a&
      &bb8n6*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+abb8n7*(Q(1)*Q(1)-Q(2&
      &)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+t1*abb8n10*(Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)&
      &-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))+t1*abb8n11*(Q(1)*spvak1k6(1)-Q(2)*spv&
      &ak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))+t1*abb8n2*(Q(1)*spvak5k2(1)-Q&
      &(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t1*abb8n3*(Q(1)*k6(1)-&
      &Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+t1*abb8n4*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k&
      &1(3)-Q(4)*k1(4))+t1*abb8n4*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+&
      &t1*abb8n9*(Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5&
      &k6(4)))
      numerator = cmplx(real(d8, ki), aimag(d8), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p17_ddbar_neepdubar_globalsl1, only: epspow
      use p17_ddbar_neepdubar_kinematics
      use p17_ddbar_neepdubar_abbrevd8h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d8
      complex(ki) :: t1

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k6-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d8 = 0.0_ki
      t1 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      d8 = (t1*abb8n8+abb8n5*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)&
      &-Q(4)*spvak5k4(4))+abb8n6*(Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))+a&
      &bb8n6*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+abb8n7*(Q(1)*Q(1)-Q(2&
      &)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+t1*abb8n10*(Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)&
      &-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))+t1*abb8n11*(Q(1)*spvak1k6(1)-Q(2)*spv&
      &ak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))+t1*abb8n2*(Q(1)*spvak5k2(1)-Q&
      &(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t1*abb8n3*(Q(1)*k6(1)-&
      &Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+t1*abb8n4*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k&
      &1(3)-Q(4)*k1(4))+t1*abb8n4*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+&
      &t1*abb8n9*(Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5&
      &k6(4)))

      numerator = cmplx(real(d8, ki), aimag(d8), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p17_ddbar_neepdubar_d8h0l1
