module     p17_ddbar_neepdubar_d11h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p17_ddbar_neepdubar/helicity1/d11h1l1.f90
   ! generator: haggies (1.1)
   use p17_ddbar_neepdubar_config, only: ki
   use p17_ddbar_neepdubar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p17_ddbar_neepdubar_groups, only: &
!           & sign => diagram11_sign, shift => diagram11_shift
      use p17_ddbar_neepdubar_globalsl1, only: epspow
      use p17_ddbar_neepdubar_kinematics
      use p17_ddbar_neepdubar_abbrevd11h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d11
      complex(ki) :: t1

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(-Q_ext(4),   ki_sam), aimag(-Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3), ki_sam), aimag(-Q_ext(1:3)), ki)
      d11 = 0.0_ki
      t1 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      d11 = (abb11n2+t1*abb11n5+abb11n3*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k&
      &1(4))+abb11n3*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb11n3*(Q(1)&
      &*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb11n4*(Q(1)*spvak2k6(1)-Q(2)*s&
      &pvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+abb11n6*(Q(1)*spvak3k1(1)-Q&
      &(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+abb11n7*(Q(1)*spvak5k1&
      &(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))+abb11n8*(Q(1)*Q(1&
      &)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+t1*abb11n10*(Q(1)*spvak5k6(1)-Q(2)*spvak&
      &5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))+t1*abb11n9*(Q(1)*spvak3k6(1)-Q(&
      &2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)))
      numerator = cmplx(real(d11, ki), aimag(d11), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p17_ddbar_neepdubar_globalsl1, only: epspow
      use p17_ddbar_neepdubar_kinematics
      use p17_ddbar_neepdubar_abbrevd11h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d11
      complex(ki) :: t1

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(-Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d11 = 0.0_ki
      t1 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      d11 = (abb11n2+t1*abb11n5+abb11n3*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k&
      &1(4))+abb11n3*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb11n3*(Q(1)&
      &*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb11n4*(Q(1)*spvak2k6(1)-Q(2)*s&
      &pvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+abb11n6*(Q(1)*spvak3k1(1)-Q&
      &(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+abb11n7*(Q(1)*spvak5k1&
      &(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))+abb11n8*(Q(1)*Q(1&
      &)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+t1*abb11n10*(Q(1)*spvak5k6(1)-Q(2)*spvak&
      &5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))+t1*abb11n9*(Q(1)*spvak3k6(1)-Q(&
      &2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)))

      numerator = cmplx(real(d11, ki), aimag(d11), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p17_ddbar_neepdubar_d11h1l1
