module     p18_ddbar_neepscbar_d26h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p18_ddbar_neepscbar/helicity0/d26h0l1.f90
   ! generator: haggies (1.1)
   use p18_ddbar_neepscbar_config, only: ki
   use p18_ddbar_neepscbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p18_ddbar_neepscbar_groups, only: &
!           & sign => diagram26_sign, shift => diagram26_shift
      use p18_ddbar_neepscbar_globalsl1, only: epspow
      use p18_ddbar_neepscbar_kinematics
      use p18_ddbar_neepscbar_abbrevd26h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d26

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(+Q_ext(4),   ki_sam), aimag(+Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3), ki_sam), aimag(+Q_ext(1:3)), ki)
      d26 = 0.0_ki
      d26 = (abb26n1+abb26n2*(Q(1)*spvak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)&
      &-Q(4)*spvak1k4(4))+abb26n3*(Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1&
      &k6(3)-Q(4)*spvak1k6(4))+abb26n4*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*s&
      &pvak5k4(3)-Q(4)*spvak5k4(4))+abb26n5*(Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(&
      &4)*k3(4))+abb26n5*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+abb26n5*(&
      &Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb26n6*(Q(1)*spvak5k6(1)-Q(&
      &2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))+abb26n7*(Q(1)*spvak3k4(&
      &1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))+abb26n8*(Q(1)*spva&
      &k3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)))
      numerator = cmplx(real(d26, ki), aimag(d26), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p18_ddbar_neepscbar_globalsl1, only: epspow
      use p18_ddbar_neepscbar_kinematics
      use p18_ddbar_neepscbar_abbrevd26h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d26

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(+Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d26 = 0.0_ki
      d26 = (abb26n1+abb26n2*(Q(1)*spvak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)&
      &-Q(4)*spvak1k4(4))+abb26n3*(Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1&
      &k6(3)-Q(4)*spvak1k6(4))+abb26n4*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*s&
      &pvak5k4(3)-Q(4)*spvak5k4(4))+abb26n5*(Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(&
      &4)*k3(4))+abb26n5*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+abb26n5*(&
      &Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb26n6*(Q(1)*spvak5k6(1)-Q(&
      &2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))+abb26n7*(Q(1)*spvak3k4(&
      &1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))+abb26n8*(Q(1)*spva&
      &k3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)))

      numerator = cmplx(real(d26, ki), aimag(d26), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p18_ddbar_neepscbar_d26h0l1
