module     p18_ddbar_neepscbar_abbrevd33h1
   use p18_ddbar_neepscbar_config, only: ki
   use p18_ddbar_neepscbar_globalsh1
   implicit none
   private
   complex(ki), public :: abb33n1
   complex(ki), public :: abb33n2
   complex(ki), public :: abb33n3
   complex(ki), public :: abb33n4
   complex(ki), public :: abb33n5
   complex(ki), public :: abb33n6
   complex(ki), public :: abb33n7
   complex(ki), public :: abb33n8
   complex(ki), public :: abb33n9
   complex(ki), public :: abb33n10
   complex(ki), public :: abb33n11
   complex(ki), public :: rat2d33
   complex(ki), public :: abb33n13
   complex(ki), public :: abb33n14
   complex(ki), public :: abb33n15
   complex(ki), public :: abb33n16
   complex(ki), public :: abb33n17
   complex(ki), public :: abb33n18
   complex(ki), public :: abb33n19
   complex(ki), public :: abb33n20
   complex(ki), public :: abb33n21
   complex(ki), public :: abb33n22
   complex(ki), public :: abb33n23
   complex(ki), public :: abb33n24
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   real(ki) :: t12
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p18_ddbar_neepscbar_config, only: deltaOS
      use p18_ddbar_neepscbar_kinematics
      use p18_ddbar_neepscbar_model
      use p18_ddbar_neepscbar_color, only: TR
      use p18_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = c1*i_*spak2k5
      t2 = t1*spak3k6
      t12 = TR*TR
      t3 = t12*t2*spbk5k1*spbk6k4
      t4 = (es12+es34-(es56+es345))*(es34+wW*mW*i_-mW*mW)
      t5 = NC*NC*t4
      t6 = c2*i_*spak2k5
      t7 = t6*spak3k6
      t8 = NC*t4
      abb33n1 = ((4.0_ki)*(t3/t4+t3/t5-(2.0_ki)*t12*t7/t8*spbk5k1*spbk6k4))
      t3 = t1*spak3k4
      t9 = t12*t3*spbk2k1*spbk6k4
      t10 = t6*spak3k4
      abb33n2 = ((4.0_ki)*(t12*(2.0_ki)*t10/t8*spbk2k1*spbk6k4-(t9/t5+t9/t4)))
      t9 = t12*t2*spbk2k1*spbk6k4
      abb33n3 = ((4.0_ki)*((2.0_ki)*t12*t7/t8*spbk2k1*spbk6k4-(t9/t5+t9/t4)))
      t9 = t12*t3*spbk5k1*spbk6k4
      abb33n4 = ((4.0_ki)*(t9/t4+t9/t5-t12*(2.0_ki)*t10/t8*spbk5k1*spbk6k4))
      t9 = t12*t3*spbk4k1*spbk6k4
      t11 = t12*t2*spbk6k1*spbk6k4
      abb33n5 = ((8.0_ki)*(-(t12*t7/t8*spbk6k1*spbk6k4+t12*t10/t8*spbk4k1*spbk6k&
      &4))+(4.0_ki)*(t11/t4+t11/t5+t9/t4+t9/t5))
      t9 = t12*t3*spbk4k2*spbk6k4
      t11 = t12*t2*spbk6k2*spbk6k4
      abb33n6 = ((8.0_ki)*(t12*t10/t8*spbk4k2*spbk6k4+t12*t7/t8*spbk6k2*spbk6k4)&
      &+(4.0_ki)*(-(t9/t5+t9/t4+t11/t5+t11/t4)))
      t9 = t12*t1*spbk4k3
      abb33n7 = ((4.0_ki)*(t9/t4+t9/t5-(2.0_ki)*t12*t6/t8*spbk4k3))
      t3 = t12*t3*spbk5k4*spbk6k4
      t2 = t12*t2*spbk6k4*spbk6k5
      abb33n8 = ((8.0_ki)*(t12*t10/t8*spbk5k4*spbk6k4-t12*t7/t8*spbk6k4*spbk6k5)&
      &+(4.0_ki)*(t2/t4+t2/t5-(t3/t5+t3/t4)))
      t2 = t12*t1*spbk6k3
      abb33n9 = ((4.0_ki)*((2.0_ki)*t12*t6/t8*spbk6k3-(t2/t5+t2/t4)))
      t1 = t12*t1*spbk6k4
      t2 = t1/t4
      t1 = t1/t5
      t3 = (2.0_ki)*t12*t6/t8*spbk6k4
      abb33n10 = ((8.0_ki)*(t1+t2-t3))
      abb33n11 = ((4.0_ki)*(t3-(t2+t1)))
      rat2d33 = 0
      rat2 = rat2 + rat2d33
      abb33n13 = -(abb33n1)
      abb33n14 = abb33n11
      abb33n15 = abb33n10
      abb33n16 = abb33n9
      abb33n17 = abb33n7
      abb33n18 = abb33n5
      abb33n19 = -(abb33n2)
      abb33n20 = -(abb33n3)
      abb33n21 = -(abb33n4)
      abb33n22 = ((2.0_ki)*abb33n5)
      abb33n23 = -(abb33n6)
      abb33n24 = -(abb33n8)
   end subroutine
end module p18_ddbar_neepscbar_abbrevd33h1
