module     p18_ddbar_neepscbar_d27h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p18_ddbar_neepscbar/helicity1/d27h1l1d.f90
   ! generator: haggies (1.1)
   use p18_ddbar_neepscbar_config, only: ki
   use p18_ddbar_neepscbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d27
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p18_ddbar_neepscbar_globalsl1, only: epspow
      use p18_ddbar_neepscbar_kinematics
      use p18_ddbar_neepscbar_abbrevd27h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb27n11+abb27n20*(spvak3k1(1)*qshift(1)-spvak3k1(2)*qshif&
         &t(2)-spvak3k1(3)*qshift(3)-spvak3k1(4)*qshift(4))+abb27n21*(spvak5k1(1&
         &)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-spvak5k1(4)*qs&
         &hift(4))+abb27n22*dotproduct(k1, qshift)+abb27n22*dotproduct(k2, qshif&
         &t)+abb27n23*dotproduct(k6, qshift)+abb27n24*(spvak3k6(1)*qshift(1)-spv&
         &ak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-spvak3k6(4)*qshift(4))+abb27n&
         &25*(spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-&
         &spvak5k6(4)*qshift(4))+abb27n26*(spvak2k6(1)*qshift(1)-spvak2k6(2)*qsh&
         &ift(2)-spvak2k6(3)*qshift(3)-spvak2k6(4)*qshift(4))+abb27n27*(spvak2k1&
         &(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-spvak2k1(4)*&
         &qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb27n17+k2(iv1)*abb27n17+k6(iv1)*abb27n16+spvak2k&
         &1(iv1)*abb27n12+spvak2k6(iv1)*abb27n13+spvak3k1(iv1)*abb27n19+spvak3k6&
         &(iv1)*abb27n15+spvak5k1(iv1)*abb27n18+spvak5k6(iv1)*abb27n14)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d27:
   subroutine     reconstruct_d27(coeffs)
      use p18_ddbar_neepscbar_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_27:
      coeffs%coeffs_27%c0 = derivative(czip)
      coeffs%coeffs_27%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_27%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_27%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_27%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_27:
   end subroutine reconstruct_d27
!---#] subroutine reconstruct_d27:
end module p18_ddbar_neepscbar_d27h1l1d
