module     p24_udbar_neepuubar_d54h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p24_udbar_neepuubar/helicity0/d54h0l1d.f90
   ! generator: haggies (1.1)
   use p24_udbar_neepuubar_config, only: ki
   use p24_udbar_neepuubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d54
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p24_udbar_neepuubar_globalsl1, only: epspow
      use p24_udbar_neepuubar_kinematics
      use p24_udbar_neepuubar_abbrevd54h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k3+k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb54n11+abb54n20*(spvak2k1(1)*qshift(1)-spvak2k1(2)*qshif&
         &t(2)-spvak2k1(3)*qshift(3)-spvak2k1(4)*qshift(4))+abb54n21*(spvak3k1(1&
         &)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-spvak3k1(4)*qs&
         &hift(4))+abb54n22*(spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k&
         &5(3)*qshift(3)-spvak2k5(4)*qshift(4))+abb54n23*dotproduct(k5, qshift)+&
         &abb54n23*dotproduct(k6, qshift)+abb54n24*dotproduct(k1, qshift)+abb54n&
         &25*(spvak3k5(1)*qshift(1)-spvak3k5(2)*qshift(2)-spvak3k5(3)*qshift(3)-&
         &spvak3k5(4)*qshift(4))+abb54n26*(spvak6k5(1)*qshift(1)-spvak6k5(2)*qsh&
         &ift(2)-spvak6k5(3)*qshift(3)-spvak6k5(4)*qshift(4))+abb54n27*(spvak6k1&
         &(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-spvak6k1(4)*&
         &qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb54n15+k5(iv1)*abb54n16+k6(iv1)*abb54n16+spvak2k&
         &1(iv1)*abb54n19+spvak2k5(iv1)*abb54n17+spvak3k1(iv1)*abb54n18+spvak3k5&
         &(iv1)*abb54n14+spvak6k1(iv1)*abb54n12+spvak6k5(iv1)*abb54n13)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d54:
   subroutine     reconstruct_d54(coeffs)
      use p24_udbar_neepuubar_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_54:
      coeffs%coeffs_54%c0 = derivative(czip)
      coeffs%coeffs_54%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_54%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_54%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_54%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_54:
   end subroutine reconstruct_d54
!---#] subroutine reconstruct_d54:
end module p24_udbar_neepuubar_d54h0l1d
