module     p24_udbar_neepuubar_d7h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p24_udbar_neepuubar/helicity1/d7h1l1d.f90
   ! generator: haggies (1.1)
   use p24_udbar_neepuubar_config, only: ki
   use p24_udbar_neepuubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d7
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p24_udbar_neepuubar_globalsl1, only: epspow
      use p24_udbar_neepuubar_kinematics
      use p24_udbar_neepuubar_abbrevd7h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t2 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t3 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb7n10*dotproduct(qshift, qshift)+abb7n12*(spvak2k4(1)*qs&
         &hift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-spvak2k4(4)*qshift&
         &(4))+abb7n8*(spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k4(3)*q&
         &shift(3)-spvak5k4(4)*qshift(4))+t1*t2*abb7n11+t2*t3*abb7n9)
         return
      end if
      t4 = spvak2k6(iv1)
      t5 = spvak3k4(iv1)
      t6 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (qshift(iv1)*abb7n13+spvak2k4(iv1)*abb7n12+spvak5k4(iv1)*ab&
         &b7n8+t1*t5*abb7n11+t2*t4*abb7n11+t2*t6*abb7n9+t3*t5*abb7n9)
         return
      end if
      t1 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb7n10+spvak2k6(iv2)*t5*abb7n11+spvak&
         &5k6(iv2)*t5*abb7n9+t1*t4*abb7n11+t1*t6*abb7n9)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d7:
   subroutine     reconstruct_d7(coeffs)
      use p24_udbar_neepuubar_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_7:
      coeffs%coeffs_7%c0 = derivative(czip)
      coeffs%coeffs_7%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_7%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_7%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_7%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_7%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_7%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_7%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_7%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_7%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_7%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_7%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_7%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_7%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_7%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_7:
   end subroutine reconstruct_d7
!---#] subroutine reconstruct_d7:
end module p24_udbar_neepuubar_d7h1l1d
