module     p26_udbar_neepgg_d51h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity0/d51h0l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d51
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd51h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(deg.eq.0) then
         numerator = abb51n24
         return
      end if
      t1 = k1(iv1)
      t2 = k3(iv1)
      t3 = k4(iv1)
      t4 = k5(iv1)
      t5 = k6(iv1)
      t6 = spvak3k1(iv1)
      t7 = spvak3k4(iv1)
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb51n44+spvak2k5(iv1)*abb51n29+spvak2k6(iv1)*abb5&
         &1n30+t1*abb51n43+t2*abb51n42+t3*abb51n42+t4*abb51n32+t5*abb51n33+t6*ab&
         &b51n40+t7*abb51n41)
         return
      end if
      t8 = k5(iv2)
      t9 = k6(iv2)
      t10 = k1(iv2)
      t11 = k3(iv2)
      t12 = k4(iv2)
      t13 = spvak2k1(iv2)
      t14 = spvak2k4(iv2)
      t15 = spvak3k1(iv2)
      t16 = spvak3k4(iv2)
      t17 = spvak2k1(iv1)
      t18 = spvak2k4(iv1)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb51n31+t1*t8*abb51n36+t1*t9*abb51n37&
         &+t10*t4*abb51n36+t10*t5*abb51n37+t11*t4*abb51n37+t11*t5*abb51n36+t12*t&
         &4*abb51n37+t12*t5*abb51n36+t13*t4*abb51n39+t13*t5*abb51n38+t14*t4*abb5&
         &1n28+t14*t5*abb51n27+t15*t4*abb51n25+t15*t5*abb51n26+t16*t4*abb51n34+t&
         &16*t5*abb51n35+t17*t8*abb51n39+t17*t9*abb51n38+t18*t8*abb51n28+t18*t9*&
         &abb51n27+t2*t8*abb51n37+t2*t9*abb51n36+t3*t8*abb51n37+t3*t9*abb51n36+t&
         &6*t8*abb51n25+t6*t9*abb51n26+t7*t8*abb51n34+t7*t9*abb51n35)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d51:
   subroutine     reconstruct_d51(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_51:
      coeffs%coeffs_51%c0 = derivative(czip)
      coeffs%coeffs_51%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_51%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_51%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_51%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_51%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_51%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_51%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_51%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_51%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_51%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_51%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_51%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_51%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_51%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_51:
   end subroutine reconstruct_d51
!---#] subroutine reconstruct_d51:
end module p26_udbar_neepgg_d51h0l1d
