module     p26_udbar_neepgg_d16h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity1/d16h1l1.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p26_udbar_neepgg_groups, only: &
!           & sign => diagram16_sign, shift => diagram16_shift
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd16h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d16
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(+Q_ext(4),   ki_sam), aimag(+Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3), ki_sam), aimag(+Q_ext(1:3)), ki)
      d16 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = t1*t1
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t8 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t11 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      d16 = (abb16n1+t1*abb16n20+t2*abb16n24+t3*abb16n25+t3*t3*abb16n31+t4*abb16&
      &n26+t4*t4*abb16n31+t5*abb16n3+t6*abb16n4+t7*abb16n6+t8*abb16n7+t9*abb16n9&
      &+t1*t10*abb16n16+t1*t3*abb16n35+t1*t4*abb16n34+t1*t5*abb16n2+t1*t6*abb16n&
      &22+t1*t7*abb16n21+t1*t8*abb16n40+t1*t9*abb16n5+t10*t3*abb16n13+t10*t4*abb&
      &16n15+t10*t6*abb16n14+t10*t7*abb16n15+t11*t5*abb16n8+t2*t5*abb16n23+t3*t4&
      &*abb16n27+t3*t5*abb16n10+t3*t6*abb16n30+t3*t7*abb16n28+t3*t8*abb16n38+t4*&
      &t5*abb16n12+t4*t6*abb16n29+t4*t7*abb16n31+t4*t8*abb16n36+t5*t6*abb16n11+t&
      &5*t8*abb16n18+t5*abb16n17*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k&
      &6(3)-Q(4)*spvak2k6(4))+t6*t8*abb16n37+t7*t8*abb16n36+t1*t11*t5*abb16n19+t&
      &1*t3*t5*abb16n32+t1*t4*t5*abb16n33+t1*t5*t8*abb16n39)
      numerator = cmplx(real(d16, ki), aimag(d16), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd16h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d16
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(+Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d16 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = t1*t1
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t8 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t11 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      d16 = (abb16n1+t1*abb16n20+t2*abb16n24+t3*abb16n25+t3*t3*abb16n31+t4*abb16&
      &n26+t4*t4*abb16n31+t5*abb16n3+t6*abb16n4+t7*abb16n6+t8*abb16n7+t9*abb16n9&
      &+t1*t10*abb16n16+t1*t3*abb16n35+t1*t4*abb16n34+t1*t5*abb16n2+t1*t6*abb16n&
      &22+t1*t7*abb16n21+t1*t8*abb16n40+t1*t9*abb16n5+t10*t3*abb16n13+t10*t4*abb&
      &16n15+t10*t6*abb16n14+t10*t7*abb16n15+t11*t5*abb16n8+t2*t5*abb16n23+t3*t4&
      &*abb16n27+t3*t5*abb16n10+t3*t6*abb16n30+t3*t7*abb16n28+t3*t8*abb16n38+t4*&
      &t5*abb16n12+t4*t6*abb16n29+t4*t7*abb16n31+t4*t8*abb16n36+t5*t6*abb16n11+t&
      &5*t8*abb16n18+t5*abb16n17*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k&
      &6(3)-Q(4)*spvak2k6(4))+t6*t8*abb16n37+t7*t8*abb16n36+t1*t11*t5*abb16n19+t&
      &1*t3*t5*abb16n32+t1*t4*t5*abb16n33+t1*t5*t8*abb16n39)

      numerator = cmplx(real(d16, ki), aimag(d16), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p26_udbar_neepgg_d16h1l1
