module     p26_udbar_neepgg_d16h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity1/d16h1l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d16
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd16h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      real(ki) :: t31
      real(ki) :: t32
      real(ki) :: t33
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb16n42
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k5(iv1)
      t4 = k6(iv1)
      t5 = spvak3k4(iv1)
      t6 = spvak5k1(iv1)
      t7 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb16n58+t2*abb16n74+t3*abb16n57+t4*abb16n77+t5*abb16n8&
         &0+t6*abb16n76+t7*abb16n63)
         return
      end if
      t31 = d(iv1,iv2)
      t8 = k1(iv2)
      t9 = k5(iv2)
      t10 = spvak5k6(iv2)
      t11 = k6(iv2)
      t12 = spvak2k4(iv2)
      t13 = spvak3k4(iv2)
      t14 = t1*t13
      t15 = spvak5k1(iv2)
      t16 = spvak2k4(iv1)
      t17 = t5*t8
      t18 = t13*t3
      t19 = t5*t9
      t20 = spvak2k1(iv1)
      t21 = t13*t20
      t22 = spvak2k1(iv2)
      t23 = t22*t5
      t24 = t15*t5
      t25 = t10*t5
      t26 = t13*t6
      t27 = t13*t7
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t31*abb16n79+t1*t8*abb16n52+t10*t7*abb16n59+t3*t&
         &9*abb16n52)+t14*abb16n73+t17*abb16n73+t18*abb16n71+t19*abb16n71+t21*ab&
         &b16n75+t23*abb16n75+t24*abb16n65+t25*abb16n81+t26*abb16n65+t27*abb16n8&
         &1+k2(iv2)*t7*abb16n78+spvak2k6(iv1)*t13*abb16n66+spvak2k6(iv2)*t5*abb1&
         &6n66+t1*t10*abb16n48+t1*t11*abb16n55+t1*t12*abb16n70+t1*t15*abb16n45+t&
         &1*t9*abb16n56+t10*t16*abb16n67+t10*t2*abb16n78+t10*t3*abb16n49+t10*t4*&
         &abb16n62+t10*t6*abb16n43+t11*t16*abb16n68+t11*t3*abb16n52+t11*t6*abb16&
         &n47+t11*t7*abb16n62+t12*t3*abb16n68+t12*t4*abb16n68+t12*t7*abb16n67+t1&
         &5*t3*abb16n47+t15*t4*abb16n47+t15*t7*abb16n43+t16*t8*abb16n70+t16*t9*a&
         &bb16n68+t3*t8*abb16n56+t4*t8*abb16n55+t4*t9*abb16n52+t6*t8*abb16n45+t6&
         &*t9*abb16n47+t7*t8*abb16n48+t7*t9*abb16n49)
         return
      end if
      t32 = d(iv2,iv3)
      t33 = d(iv1,iv3)
      t2 = k1(iv3)
      t4 = k5(iv3)
      t11 = spvak3k4(iv3)
      t28 = spvak5k1(iv3)
      t29 = spvak5k6(iv3)
      t30 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k4(iv3)*t31*abb16n69+t1*t32*abb16n53+t10*t&
         &33*abb16n61+t11*t31*abb16n72+t12*t33*abb16n69+t13*t33*abb16n72+t15*t33&
         &*abb16n46+t16*t32*abb16n69+t2*t31*abb16n53+t25*t29*abb16n60+t27*t29*ab&
         &b16n60+t28*t31*abb16n46+t29*t31*abb16n61+t3*t32*abb16n54+t31*t4*abb16n&
         &54+t32*t5*abb16n72+t32*t6*abb16n46+t32*t7*abb16n61+t33*t8*abb16n53+t33&
         &*t9*abb16n54+t10*t11*t7*abb16n60)+t14*t29*abb16n51+t17*t29*abb16n51+t1&
         &8*t29*abb16n50+t19*t29*abb16n50+t21*t29*abb16n64+t23*t29*abb16n64+t24*&
         &t29*abb16n44+t26*t29*abb16n44+t1*t10*t11*abb16n51+t10*t11*t20*abb16n64&
         &+t10*t11*t3*abb16n50+t10*t11*t6*abb16n44+t10*t2*t5*abb16n51+t10*t28*t5&
         &*abb16n44+t10*t30*t5*abb16n64+t10*t4*t5*abb16n50+t11*t15*t7*abb16n44+t&
         &11*t22*t7*abb16n64+t11*t7*t8*abb16n51+t11*t7*t9*abb16n50+t13*t2*t7*abb&
         &16n51+t13*t28*t7*abb16n44+t13*t30*t7*abb16n64+t13*t4*t7*abb16n50)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d16:
   subroutine     reconstruct_d16(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_16:
      coeffs%coeffs_16%c0 = derivative(czip)
      coeffs%coeffs_16%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_16%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_16%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_16%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_16%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_16%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_16%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_16%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_16%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_16%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_16%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_16%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_16%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_16%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_16%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_16%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_16%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_16%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_16%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_16%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_16%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_16%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_16%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_16%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_16%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_16%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_16%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_16%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_16%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_16%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_16%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_16%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_16%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_16%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_16:
   end subroutine reconstruct_d16
!---#] subroutine reconstruct_d16:
end module p26_udbar_neepgg_d16h1l1d
