module     p26_udbar_neepgg_d21h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity1/d21h1l1.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p26_udbar_neepgg_groups, only: &
!           & sign => diagram21_sign, shift => diagram21_shift
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd21h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d21
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k2
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d21 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = t1*t1
      t3 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t4 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t5 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t8 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t9 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t10 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      d21 = (t1*abb21n16+t10*abb21n5+t2*abb21n1+t3*abb21n11+t4*abb21n12+t5*abb21&
      &n13+t6*abb21n20+t7*abb21n21+t8*abb21n3+t9*abb21n4+t1*t10*abb21n10+t1*t3*a&
      &bb21n7+t1*t4*abb21n17+t1*t5*abb21n18+t1*t6*abb21n29+t1*t7*abb21n28+t1*t8*&
      &abb21n2+t1*t9*abb21n33+t1*abb21n6*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)&
      &*spvak2k4(3)-Q(4)*spvak2k4(4))+t10*t4*abb21n8+t10*t5*abb21n9+t10*t8*abb21&
      &n14+t2*t8*abb21n19+t4*t6*abb21n24+t4*t7*abb21n23+t4*t9*abb21n30+t5*t6*abb&
      &21n22+t5*t7*abb21n25+t5*t9*abb21n31+t1*t6*t8*abb21n26+t1*t7*t8*abb21n27+t&
      &1*t8*t9*abb21n32+t1*t8*abb21n15*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*s&
      &pvak2k1(3)-Q(4)*spvak2k1(4)))
      numerator = cmplx(real(d21, ki), aimag(d21), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd21h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d21
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k2
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d21 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = t1*t1
      t3 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t4 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t5 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t8 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t9 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t10 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      d21 = (t1*abb21n16+t10*abb21n5+t2*abb21n1+t3*abb21n11+t4*abb21n12+t5*abb21&
      &n13+t6*abb21n20+t7*abb21n21+t8*abb21n3+t9*abb21n4+t1*t10*abb21n10+t1*t3*a&
      &bb21n7+t1*t4*abb21n17+t1*t5*abb21n18+t1*t6*abb21n29+t1*t7*abb21n28+t1*t8*&
      &abb21n2+t1*t9*abb21n33+t1*abb21n6*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)&
      &*spvak2k4(3)-Q(4)*spvak2k4(4))+t10*t4*abb21n8+t10*t5*abb21n9+t10*t8*abb21&
      &n14+t2*t8*abb21n19+t4*t6*abb21n24+t4*t7*abb21n23+t4*t9*abb21n30+t5*t6*abb&
      &21n22+t5*t7*abb21n25+t5*t9*abb21n31+t1*t6*t8*abb21n26+t1*t7*t8*abb21n27+t&
      &1*t8*t9*abb21n32+t1*t8*abb21n15*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*s&
      &pvak2k1(3)-Q(4)*spvak2k1(4)))

      numerator = cmplx(real(d21, ki), aimag(d21), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p26_udbar_neepgg_d21h1l1
