module     p26_udbar_neepgg_d37h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity1/d37h1l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d37
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd37h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      real(ki) :: t6
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t6 = dotproduct(k1, qshift)
      t2 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb37n10+t1*abb37n14+t2*abb37n16+t6*abb37n15+abb37n13*dotp&
         &roduct(qshift, qshift)+abb37n15*dotproduct(k5, qshift)+t1*t2*abb37n11+&
         &t1*t6*abb37n12)
         return
      end if
      t3 = k1(iv1)
      t4 = spvak5k1(iv1)
      t5 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (k5(iv1)*abb37n15+qshift(iv1)*abb37n17+t3*abb37n15+t4*abb37&
         &n16+t5*abb37n14+t1*t3*abb37n12+t1*t4*abb37n11+t2*t5*abb37n11+t5*t6*abb&
         &37n12)
         return
      end if
      t1 = spvak5k6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb37n13+k1(iv2)*t5*abb37n12+spvak5k1(&
         &iv2)*t5*abb37n11+t1*t3*abb37n12+t1*t4*abb37n11)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d37:
   subroutine     reconstruct_d37(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_37:
      coeffs%coeffs_37%c0 = derivative(czip)
      coeffs%coeffs_37%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_37%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_37%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_37%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_37%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_37%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_37%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_37%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_37%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_37%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_37%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_37%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_37%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_37%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_37:
   end subroutine reconstruct_d37
!---#] subroutine reconstruct_d37:
end module p26_udbar_neepgg_d37h1l1d
