module     p26_udbar_neepgg_d16h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity3/d16h3l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d16
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd16h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      real(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb16n45
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k5(iv1)
      t4 = k6(iv1)
      t5 = spvak2k4(iv1)
      t6 = spvak3k4(iv1)
      t7 = spvak5k1(iv1)
      t8 = spvak5k6(iv1)
      t9 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb16n71+t2*abb16n87+t3*abb16n72+t4*abb16n85+t5*abb16n8&
         &3+t6*abb16n84+t7*abb16n66+t8*abb16n73+t9*abb16n69)
         return
      end if
      t34 = d(iv1,iv2)
      t10 = k1(iv2)
      t11 = k5(iv2)
      t12 = k6(iv2)
      t13 = spvak2k4(iv2)
      t14 = spvak3k4(iv2)
      t15 = t1*t14
      t16 = spvak5k1(iv2)
      t17 = spvak5k6(iv2)
      t18 = spvak6k5(iv2)
      t19 = t10*t6
      t20 = t14*t3
      t21 = t11*t6
      t22 = spvak2k1(iv1)
      t23 = t14*t22
      t24 = spvak2k1(iv2)
      t25 = t24*t6
      t26 = t16*t6
      t27 = t17*t6
      t28 = t14*t7
      t29 = t14*t8
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t34*abb16n68+t1*t10*abb16n53+t11*t3*abb16n53)+t1&
         &5*abb16n74+t19*abb16n74+t20*abb16n75+t21*abb16n75+t23*abb16n86+t25*abb&
         &16n86+t26*abb16n77+t27*abb16n76+t28*abb16n77+t29*abb16n76+k2(iv2)*t9*a&
         &bb16n70+t1*t11*abb16n57+t1*t12*abb16n56+t1*t13*abb16n80+t1*t16*abb16n4&
         &7+t1*t17*abb16n61+t1*t18*abb16n51+t10*t3*abb16n57+t10*t4*abb16n56+t10*&
         &t5*abb16n80+t10*t7*abb16n47+t10*t8*abb16n61+t10*t9*abb16n51+t11*t4*abb&
         &16n53+t11*t5*abb16n78+t11*t7*abb16n49+t11*t8*abb16n63+t11*t9*abb16n52+&
         &t12*t3*abb16n53+t12*t5*abb16n78+t12*t7*abb16n49+t12*t8*abb16n63+t13*t3&
         &*abb16n78+t13*t4*abb16n78+t13*t9*abb16n67+t14*t9*abb16n82+t16*t3*abb16&
         &n49+t16*t4*abb16n49+t16*t9*abb16n46+t17*t3*abb16n63+t17*t4*abb16n63+t1&
         &7*t9*abb16n60+t18*t2*abb16n70+t18*t3*abb16n52+t18*t5*abb16n67+t18*t6*a&
         &bb16n82+t18*t7*abb16n46+t18*t8*abb16n60)
         return
      end if
      t35 = d(iv2,iv3)
      t36 = d(iv1,iv3)
      t2 = k1(iv3)
      t4 = k5(iv3)
      t12 = spvak3k4(iv3)
      t30 = spvak5k1(iv3)
      t31 = spvak5k6(iv3)
      t32 = spvak6k5(iv3)
      t33 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k4(iv3)*t34*abb16n79+t1*t35*abb16n54+t10*t&
         &36*abb16n54+t11*t36*abb16n55+t12*t34*abb16n81+t13*t36*abb16n79+t14*t36&
         &*abb16n81+t16*t36*abb16n48+t17*t36*abb16n62+t2*t34*abb16n54+t3*t35*abb&
         &16n55+t30*t34*abb16n48+t31*t34*abb16n62+t34*t4*abb16n55+t35*t5*abb16n7&
         &9+t35*t6*abb16n81+t35*t7*abb16n48+t35*t8*abb16n62)+t15*t32*abb16n59+t1&
         &9*t32*abb16n59+t20*t32*abb16n58+t21*t32*abb16n58+t23*t32*abb16n65+t25*&
         &t32*abb16n65+t26*t32*abb16n50+t27*t32*abb16n64+t28*t32*abb16n50+t29*t3&
         &2*abb16n64+t1*t12*t18*abb16n59+t10*t12*t9*abb16n59+t11*t12*t9*abb16n58&
         &+t12*t16*t9*abb16n50+t12*t17*t9*abb16n64+t12*t18*t22*abb16n65+t12*t18*&
         &t3*abb16n58+t12*t18*t7*abb16n50+t12*t18*t8*abb16n64+t12*t24*t9*abb16n6&
         &5+t14*t2*t9*abb16n59+t14*t30*t9*abb16n50+t14*t31*t9*abb16n64+t14*t33*t&
         &9*abb16n65+t14*t4*t9*abb16n58+t18*t2*t6*abb16n59+t18*t30*t6*abb16n50+t&
         &18*t31*t6*abb16n64+t18*t33*t6*abb16n65+t18*t4*t6*abb16n58)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d16:
   subroutine     reconstruct_d16(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_16:
      coeffs%coeffs_16%c0 = derivative(czip)
      coeffs%coeffs_16%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_16%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_16%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_16%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_16%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_16%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_16%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_16%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_16%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_16%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_16%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_16%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_16%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_16%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_16%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_16%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_16%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_16%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_16%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_16%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_16%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_16%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_16%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_16%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_16%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_16%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_16%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_16%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_16%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_16%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_16%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_16%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_16%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_16%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_16:
   end subroutine reconstruct_d16
!---#] subroutine reconstruct_d16:
end module p26_udbar_neepgg_d16h3l1d
