module     p3_ud_emnebaruu_d2h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p3_ud_emnebaruu/helicity0/d2h0l1d.f90
   ! generator: haggies (1.1)
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d2
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p3_ud_emnebaruu_globalsl1, only: epspow
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_abbrevd2h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      real(ki) :: t20
      real(ki) :: t21
      real(ki) :: t22
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb2n32
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k5(iv1)
      t4 = k6(iv1)
      t5 = spvak1k2(iv1)
      t6 = spvak3k4(iv1)
      t7 = spvak6k1(iv1)
      t8 = spvak6k2(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb2n48+t2*abb2n46+t3*abb2n60+t4*abb2n45+t5*abb2n54+t6*&
         &abb2n61+t7*abb2n42+t8*abb2n44)
         return
      end if
      t20 = d(iv1,iv2)
      t9 = spvak3k4(iv2)
      t10 = spvak6k1(iv2)
      t11 = spvak6k2(iv2)
      t12 = k1(iv2)
      t13 = spvak3k2(iv2)
      t14 = k2(iv2)
      t15 = spvak3k2(iv1)
      t16 = k5(iv2)
      t17 = k6(iv2)
      t18 = spvak5k2(iv1)
      t19 = spvak5k2(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*t20*abb2n47+spvak1k2(iv2)*t7*abb2n53+spvak5k1(iv1&
         &)*t10*abb2n55+spvak5k1(iv2)*t7*abb2n55+spvak5k6(iv1)*t10*abb2n38+spvak&
         &5k6(iv2)*t7*abb2n38+t1*t10*abb2n41+t1*t11*abb2n51+t1*t9*abb2n59+t10*t1&
         &5*abb2n34+t10*t18*abb2n36+t10*t3*abb2n41+t10*t4*abb2n39+t10*t5*abb2n53&
         &+t10*t6*abb2n37+t10*t8*abb2n35+t11*t3*abb2n53+t11*t4*abb2n53+t11*t6*ab&
         &b2n43+t11*t7*abb2n35+t12*t6*abb2n59+t12*t7*abb2n41+t12*t8*abb2n51+t13*&
         &t2*abb2n50+t13*t7*abb2n34+t14*t15*abb2n50+t14*t6*abb2n57+t16*t7*abb2n4&
         &1+t16*t8*abb2n53+t17*t6*abb2n56+t17*t7*abb2n39+t17*t8*abb2n53+t19*t7*a&
         &bb2n36+t2*t9*abb2n57+t4*t9*abb2n56+t7*t9*abb2n37+t8*t9*abb2n43)
         return
      end if
      t21 = d(iv2,iv3)
      t22 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t2 = spvak6k1(iv3)
      t3 = spvak5k2(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k2(iv3)*t20*abb2n49+spvak6k2(iv3)*t20*abb2&
         &n52+t1*t20*abb2n58+t10*t22*abb2n40+t11*t22*abb2n52+t13*t22*abb2n49+t15&
         &*t21*abb2n49+t2*t20*abb2n40+t21*t6*abb2n58+t21*t7*abb2n40+t21*t8*abb2n&
         &52+t22*t9*abb2n58)+t1*t10*t18*abb2n33+t1*t19*t7*abb2n33+t10*t3*t6*abb2&
         &n33+t18*t2*t9*abb2n33+t19*t2*t6*abb2n33+t3*t7*t9*abb2n33)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d2:
   subroutine     reconstruct_d2(coeffs)
      use p3_ud_emnebaruu_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_2:
      coeffs%coeffs_2%c0 = derivative(czip)
      coeffs%coeffs_2%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_2%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_2%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_2%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_2%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_2%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_2%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_2%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_2%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_2%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_2%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_2%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_2%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_2%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_2%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_2%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_2%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_2%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_2%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_2%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_2%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_2%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_2%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_2%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_2%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_2%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_2%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_2%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_2%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_2%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_2%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_2%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_2%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_2%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_2:
   end subroutine reconstruct_d2
!---#] subroutine reconstruct_d2:
end module p3_ud_emnebaruu_d2h0l1d
