module     p3_ud_emnebaruu_d52h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p3_ud_emnebaruu/helicity1/d52h1l1d.f90
   ! generator: haggies (1.1)
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d52
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p3_ud_emnebaruu_globalsl1, only: epspow
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_abbrevd52h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb52n11+abb52n12*(spvak1k2(1)*qshift(1)-spvak1k2(2)*qshif&
         &t(2)-spvak1k2(3)*qshift(3)-spvak1k2(4)*qshift(4))+abb52n13*(spvak1k4(1&
         &)*qshift(1)-spvak1k4(2)*qshift(2)-spvak1k4(3)*qshift(3)-spvak1k4(4)*qs&
         &hift(4))+abb52n14*(spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k&
         &2(3)*qshift(3)-spvak6k2(4)*qshift(4))+abb52n15*(spvak6k4(1)*qshift(1)-&
         &spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(3)-spvak6k4(4)*qshift(4))+abb&
         &52n16*dotproduct(k2, qshift)+abb52n17*dotproduct(k3, qshift)+abb52n17*&
         &dotproduct(k4, qshift)+abb52n18*(spvak3k4(1)*qshift(1)-spvak3k4(2)*qsh&
         &ift(2)-spvak3k4(3)*qshift(3)-spvak3k4(4)*qshift(4))+abb52n19*(spvak3k2&
         &(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-spvak3k2(4)*&
         &qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb52n16+k3(iv1)*abb52n17+k4(iv1)*abb52n17+spvak1k&
         &2(iv1)*abb52n12+spvak1k4(iv1)*abb52n13+spvak3k2(iv1)*abb52n19+spvak3k4&
         &(iv1)*abb52n18+spvak6k2(iv1)*abb52n14+spvak6k4(iv1)*abb52n15)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d52:
   subroutine     reconstruct_d52(coeffs)
      use p3_ud_emnebaruu_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_52:
      coeffs%coeffs_52%c0 = derivative(czip)
      coeffs%coeffs_52%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_52%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_52%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_52%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_52:
   end subroutine reconstruct_d52
!---#] subroutine reconstruct_d52:
end module p3_ud_emnebaruu_d52h1l1d
