module     p7_dubar_emnebargg_d39h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity1/d39h1l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d39
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd39h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      real(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t3 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t4 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t15 = dotproduct(k5, qshift)
      t16 = dotproduct(k6, qshift)
      t17 = dotproduct(k1, qshift)
      t5 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb39n13+abb39n19*dotproduct(qshift, qshift)+abb39n22*d&
         &otproduct(k3, qshift)+abb39n22*dotproduct(k4, qshift)+abb39n23*(spvak2&
         &k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-spvak2k4(4&
         &)*qshift(4))+t1*t15*abb39n17+t1*t16*abb39n17+t1*t17*abb39n18+t1*t2*abb&
         &39n14+t1*t3*abb39n15+t1*t4*abb39n16+t1*t5*abb39n20)
         return
      end if
      t6 = spvak3k4(iv1)
      t7 = k1(iv1)
      t8 = k5(iv1)
      t9 = k6(iv1)
      t10 = spvak2k1(iv1)
      t11 = spvak2k6(iv1)
      t12 = t6*abb39n17
      t13 = spvak5k1(iv1)
      t14 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (k3(iv1)*abb39n22+k4(iv1)*abb39n22+qshift(iv1)*abb39n21+spv&
         &ak2k4(iv1)*abb39n23+t12*t15+t12*t16+t6*abb39n13+t1*t10*abb39n20+t1*t11&
         &*abb39n15+t1*t13*abb39n14+t1*t14*abb39n16+t1*t7*abb39n18+t1*t8*abb39n1&
         &7+t1*t9*abb39n17+t17*t6*abb39n18+t2*t6*abb39n14+t3*t6*abb39n15+t4*t6*a&
         &bb39n16+t5*t6*abb39n20)
         return
      end if
      t1 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb39n19+k1(iv2)*t6*abb39n18+k5(iv2)*t&
         &6*abb39n17+k6(iv2)*t6*abb39n17+spvak2k1(iv2)*t6*abb39n20+spvak2k6(iv2)&
         &*t6*abb39n15+spvak5k1(iv2)*t6*abb39n14+spvak5k6(iv2)*t6*abb39n16+t1*t1&
         &0*abb39n20+t1*t11*abb39n15+t1*t13*abb39n14+t1*t14*abb39n16+t1*t7*abb39&
         &n18+t1*t8*abb39n17+t1*t9*abb39n17)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d39:
   subroutine     reconstruct_d39(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_39:
      coeffs%coeffs_39%c0 = derivative(czip)
      coeffs%coeffs_39%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_39%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_39%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_39%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_39%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_39%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_39%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_39%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_39%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_39%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_39%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_39%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_39%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_39%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_39:
   end subroutine reconstruct_d39
!---#] subroutine reconstruct_d39:
end module p7_dubar_emnebargg_d39h1l1d
