module     p7_dubar_emnebargg_d53h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity3/d53h3l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d53
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd53h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      real(ki) :: t9
      real(ki) :: t10
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k6-k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t9 = dotproduct(k6, qshift)
      t10 = dotproduct(k5, qshift)
      t1 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t2 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb53n18+t10*abb53n26+t9*abb53n24+abb53n23*dotproduct(qshi&
         &ft, qshift)+abb53n25*dotproduct(k1, qshift)+abb53n27*(spvak6k1(1)*qshi&
         &ft(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-spvak6k1(4)*qshift(4&
         &))+abb53n28*(spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*q&
         &shift(3)-spvak5k1(4)*qshift(4))+abb53n29*(spvak2k6(1)*qshift(1)-spvak2&
         &k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-spvak2k6(4)*qshift(4))+abb53n30*&
         &(spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-spv&
         &ak3k6(4)*qshift(4))+abb53n31*(spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift&
         &(2)-spvak2k5(3)*qshift(3)-spvak2k5(4)*qshift(4))+abb53n33*(spvak3k5(1)&
         &*qshift(1)-spvak3k5(2)*qshift(2)-spvak3k5(3)*qshift(3)-spvak3k5(4)*qsh&
         &ift(4))+t1*t10*abb53n19+t1*t9*abb53n20+t10*t2*abb53n22+t2*t9*abb53n21)
         return
      end if
      t3 = k5(iv1)
      t4 = k6(iv1)
      t5 = spvak2k1(iv1)
      t6 = spvak3k1(iv1)
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb53n25+qshift(iv1)*abb53n32+spvak2k5(iv1)*abb53n&
         &31+spvak2k6(iv1)*abb53n29+spvak3k5(iv1)*abb53n33+spvak3k6(iv1)*abb53n3&
         &0+spvak5k1(iv1)*abb53n28+spvak6k1(iv1)*abb53n27+t3*abb53n26+t4*abb53n2&
         &4+t1*t3*abb53n19+t1*t4*abb53n20+t10*t5*abb53n22+t10*t6*abb53n19+t2*t3*&
         &abb53n22+t2*t4*abb53n21+t5*t9*abb53n21+t6*t9*abb53n20)
         return
      end if
      t1 = spvak2k1(iv2)
      t2 = spvak3k1(iv2)
      t7 = k5(iv2)
      t8 = k6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb53n23+t1*t3*abb53n22+t1*t4*abb53n21&
         &+t2*t3*abb53n19+t2*t4*abb53n20+t5*t7*abb53n22+t5*t8*abb53n21+t6*t7*abb&
         &53n19+t6*t8*abb53n20)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d53:
   subroutine     reconstruct_d53(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_53:
      coeffs%coeffs_53%c0 = derivative(czip)
      coeffs%coeffs_53%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_53%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_53%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_53%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_53%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_53%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_53%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_53%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_53%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_53%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_53%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_53%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_53%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_53%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_53:
   end subroutine reconstruct_d53
!---#] subroutine reconstruct_d53:
end module p7_dubar_emnebargg_d53h3l1d
